; Flash rel 0.03
; Created by Graechan
; many thanks to  K1TesseraEna and Molly for there assistance
; in creating this script
; Comments directed to http://gimpchat.com or http://gimpscripts.com
;
; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html
;
;
; ------------
;| Change Log |
; ------------ 
; Rel 0.01 - Initial Release
; Rel 0.02 - Seperated text-background from backgrond
; Rel 0.03 - added random_pattern background fill option and text opactity setting 
(define (script-fu-flash-logo 
                                      text 
                                      color 
                                      font-in 
                                      font-size
									  opacity
									  palette
									  sep
									  pattern-fill
									  shrink
									  blur
									  offx 
									  offy
                                      layers-in)
									  
  (let* (
         (image (car (gimp-image-new 256 256 RGB)))         
         (border (/ font-size 4))
		 (font (if (> (string-length font-in) 0) font-in (car (gimp-context-get-font))))
         (size-layer (car (gimp-text-fontname image -1 0 0 text border TRUE font-size PIXELS font)))
         (final-width (car (gimp-drawable-width size-layer)))
         (final-height (car (gimp-drawable-height size-layer)))
         (text-layer 0)
         (width 0)
         (height 0)
		 (text-bkg-layer 0)
         (bkg-layer 0)
		 (selection-channel 0)
		 (color-layer 0)
         ;;;;;;;;;;;;;;;;;
		 (random_color 0)
		 (random_pattern 0)
		 (copy-layer 0)
		 (layer 0)
		 (layers layers-in)
		 (entry-num 0)
		 (num-colors 0)         
         )
		 
    (gimp-context-push)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))

;;;;Add the text layer for a temporary larger Image size
    (set! text-layer (car (gimp-text-fontname image -1 0 0 text (round (/ 350 4)) TRUE 350 PIXELS font)))
    (set! width (car (gimp-drawable-width text-layer)))
    (set! height (car (gimp-drawable-height text-layer)))    
    (gimp-image-remove-layer image size-layer)
    (gimp-image-resize-to-layers image)
	
;;;;centre text on line
	(gimp-text-layer-set-justification text-layer 2)
	
;;;;set the text clolor    
    (gimp-context-set-foreground color)
	(gimp-selection-layer-alpha text-layer)
	(gimp-edit-fill text-layer FOREGROUND-FILL)
;;;;create selection-channel (gimp-selection-load selection-channel)
    (gimp-selection-save image)
	(set! selection-channel (car (gimp-image-get-active-drawable image)))	
	(gimp-channel-set-opacity selection-channel 100)	
	(gimp-drawable-set-name selection-channel "selection-channel")
    (gimp-image-set-active-layer image text-layer)	

	(set! color-layer (car (gimp-layer-new image width height RGBA-IMAGE "Color-layer" 100 NORMAL-MODE)))
    (gimp-image-add-layer image color-layer -1)
	(gimp-selection-shrink image shrink)
	(gimp-context-set-foreground '(255 255 255))
	(gimp-edit-fill color-layer FOREGROUND-FILL)
	(gimp-layer-set-offsets color-layer offx offy)
	(gimp-layer-resize-to-image-size color-layer)
	(set! text-layer (car (gimp-image-merge-down image color-layer EXPAND-AS-NECESSARY)))
	(gimp-selection-none image)
	(plug-in-gauss-rle2 RUN-NONINTERACTIVE image text-layer blur blur)
	(gimp-selection-load selection-channel)
	(gimp-selection-invert image)
    (gimp-edit-clear text-layer)
	(gimp-selection-invert image)
	(plug-in-colortoalpha 1 image text-layer '(255 255 255))
	(gimp-layer-set-opacity text-layer opacity)
	(script-fu-drop-shadow image text-layer 12 12 40 '(0 0 0) 100 FALSE)
	(set! text-layer (car (gimp-image-merge-visible-layers image 0)))
	
;;;;Scale Image to it's original size;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    (gimp-image-scale-full image final-width final-height 2)
	(set! width (car (gimp-image-width image)))
	(set! height (car (gimp-image-height image)))
	
;;;;create the animation layers
    (while (> layers 0)
	(set! random_color (car (gimp-palette-entry-get-color  palette (random  (car (gimp-palette-get-colors  palette))))))
	(set! random_pattern (list-ref (cadr (gimp-patterns-get-list "")) (round (random (car (gimp-patterns-get-list ""))))))
	(set! bkg-layer (car (gimp-layer-new image width height RGBA-IMAGE "Background" 100 NORMAL-MODE)))
    (gimp-image-add-layer image bkg-layer -1)	
	(gimp-context-set-background random_color)
	(gimp-context-set-pattern random_pattern)
    (gimp-drawable-fill bkg-layer BACKGROUND-FILL)
	(if (= pattern-fill TRUE) (gimp-drawable-fill bkg-layer PATTERN-FILL))
	(if (or (= pattern-fill TRUE) (= sep TRUE)) (begin
	(set! random_color (car (gimp-palette-entry-get-color  palette (random  (car (gimp-palette-get-colors  palette))))))
	(gimp-context-set-background random_color)
	(set! text-bkg-layer (car (gimp-layer-new image width height RGBA-IMAGE "Text Background" opacity NORMAL-MODE)))
    (gimp-image-add-layer image text-bkg-layer -1)
	(gimp-edit-fill text-bkg-layer BACKGROUND-FILL)))
	(set! copy-layer (car (gimp-layer-copy text-layer TRUE)))
    (gimp-image-add-layer image copy-layer -1)
	(if (or (= pattern-fill TRUE) (= sep TRUE)) (set! copy-layer (car (gimp-image-merge-down image copy-layer EXPAND-AS-NECESSARY))))
    (set! layer (car (gimp-image-merge-down image copy-layer EXPAND-AS-NECESSARY)))
	(set! layers (- layers 1)))
	
	(gimp-selection-none image)
	(gimp-image-remove-layer image text-layer)
	
	(gimp-context-pop)
	(gimp-display-new image)
    )
  ) 
(script-fu-register "script-fu-flash-logo"
  "Flash..."
  "Create an animation using random colors from a Palette"
  "Graechan"
  "Graechan - http://gimpchat.com"
  "Dec 2012"
  ""
  SF-TEXT       "Text"    "Text Effect"
  SF-COLOR      "Primary Color"         '(0 0 255)
  SF-FONT       "Font"               "Sans Bold"
  SF-ADJUSTMENT "Font size (pixels)" '(100 6 500 1 1 0 1)
  SF-ADJUSTMENT "Text Opacity" '(70 0 100 1 5 0 0)
  SF-PALETTE    "Palette used for Bkg-Colors" "Default"
  SF-TOGGLE     "Apply Seperate Color for Text Background"   TRUE
  SF-TOGGLE     "Apply Pattern to Background"   FALSE
  SF-ADJUSTMENT "secondary Color Reduction" '(15 1 30 1 5 0 0)
  SF-ADJUSTMENT "Colors Blur" '(35 1 60 1 5 0 0)
  SF-ADJUSTMENT "Primary Color Offeset x" '(8 -40 40 1 10 0 0)
  SF-ADJUSTMENT "Primary Color Offset y" '(5 -40 40 1 10 0 0)
  SF-ADJUSTMENT "Layers" '(10 1 50 1 10 0 1)
  
  )
(script-fu-menu-register "script-fu-flash-logo" "<Image>/File/Create/Logos")