; Hatched Logo rel 0.01
; Created by Graechan
; You will need to install GMIC to run this Scipt
; GMIC can be downloaded from http://sourceforge.net/projects/gmic/files/
; Comments directed to http://gimpchat.com or http://gimpscripts.com
;
; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html
;
;
; ------------
;| Change Log |
; ------------ 
; Rel 0.01 - Initial Release
;
;scaled pattern fill procedure
(define (scaled-pattern-fill image drawable pattern scale)
  (let* (
	      (width (car (gimp-pattern-get-info pattern)))
          (height (cadr (gimp-pattern-get-info pattern)))
		  (pat-img (car (gimp-image-new (* 5 width) (* 5 height) RGB)))
		  (pat-layer (car (gimp-layer-new pat-img (* 5 width) (* 5 height) RGBA-IMAGE "Pattern" 100 NORMAL-MODE)))
		  (new-width (* (/ (* 5 width) 100) scale))
		  (new-height (* (/ (* 5 height) 100) scale))
		  )
	(gimp-image-add-layer pat-img pat-layer	0)
    (gimp-drawable-fill pat-layer PATTERN-FILL)
	(gimp-image-scale-full pat-img new-width new-height 3)
	(plug-in-unsharp-mask 1 pat-img pat-layer 5 .5 0)
	;(plug-in-make-seamless 1 pat-img pat-layer)
	(gimp-edit-copy-visible pat-img)
	(gimp-context-set-pattern (caadr (gimp-patterns-list "")))
	(gimp-image-delete pat-img))
	(gimp-edit-fill drawable PATTERN-FILL))
;
(define list-blend-dir '("Left to Right" "Top to Bottom" "Diagonal"))
;
; include layer Procedure
(define (include-layer image newlayer oldlayer stack)	;stack 0=above 1=below
	(cond ((defined? 'gimp-image-get-item-position) ;test for 2.8 compatability
            (gimp-image-insert-layer image newlayer (car (gimp-item-get-parent oldlayer)) 
			(+ (car (gimp-image-get-layer-position image oldlayer)) stack))                                     ;For GIMP 2.8 
          )
          (else
           (gimp-image-add-layer image newlayer (+ (car (gimp-image-get-layer-position image oldlayer)) stack)) ;For GIMP 2.6 
          )
    ) ;end cond
) ;end add layer procedure

(define (script-fu-hatched-logo 
                                      text
									  justify
									  letter-spacing
									  line-spacing
                                      font-in 
                                      font-size
									  grad
									  fg-color
									  bg-color
									  gradangle
					                  gradsize
									  outline-color
									  stroke-size
									  stroke-position
									  outer-spacing
                                      bkg-type
									  bkg-color
                                      bkg-pattern
									  conserve)

  (let* (
         (image (car (gimp-image-new 256 256 RGB)))         
         (border (/ font-size 4))
		 (font (if (> (string-length font-in) 0) font-in (car (gimp-context-get-font))))
         (size-layer (car (gimp-text-fontname image -1 0 0 text border TRUE font-size PIXELS font)))
         (final-width (car (gimp-drawable-width size-layer)))
         (final-height (car (gimp-drawable-height size-layer)))
         (text-layer 0)
         (width 0)
         (height 0)
         (bkg-layer 0)
		 (ver 2.8)
		 (selection-channel 0)
         (aspect 0)
		 (justify (cond ((= justify 0) 2)
		                ((= justify 1) 0)
						((= justify 2) 1)))
		 
		 (drop-shadow 0)
		 (x1 0)
		 (y1 0)
		 (x2 0)
		 (y2 0)
         )
	(cond ((not (defined? 'gimp-image-get-item-position)) (set! ver 2.6))) ;define the gimp version	 
    
	(gimp-context-push)
	(gimp-context-set-paint-method "gimp-paintbrush")
	(if (= ver 2.8) (gimp-context-set-dynamics "Dynamics Off"))
	(gimp-context-set-foreground '(0 0 0)) ;---------------------------------set text color here
	(gimp-context-set-background '(255 255 255))
	
;;;;adjust the size-layer
    (gimp-text-layer-set-justification size-layer justify)
	(gimp-text-layer-set-letter-spacing size-layer letter-spacing)
	(gimp-text-layer-set-line-spacing size-layer line-spacing)
    (set! final-width (car (gimp-drawable-width size-layer)))
    (set! final-height (car (gimp-drawable-height size-layer)))	

;;;;Add the text layer for a temporary larger Image size
    (set! text-layer (car (gimp-text-fontname image -1 0 0 text (round (/ 400 4)) TRUE 400 PIXELS font)))
	(gimp-drawable-set-name text-layer text)
;;;;adjust text 
	(gimp-text-layer-set-justification text-layer justify)
	(gimp-text-layer-set-letter-spacing text-layer letter-spacing)
	(gimp-text-layer-set-line-spacing text-layer line-spacing)
;;;;set the new width and height	
    (set! width (car (gimp-drawable-width text-layer)))
    (set! height (car (gimp-drawable-height text-layer)))    
    (gimp-image-remove-layer image size-layer)
    (gimp-image-resize-to-layers image)

;;;;create selection-channel (cond ((= ver 2.8) (gimp-image-select-item image 2 selection-channel)) (else (gimp-selection-load selection-channel)))	
    (cond ((= ver 2.8) (gimp-image-select-item image 2 text-layer)) 
	(else (gimp-selection-layer-alpha text-layer)))
    (set! selection-channel (car (gimp-selection-save image)))
	(cond ((= ver 2.8) (gimp-item-set-name selection-channel "selection-channel"))
	(else (gimp-drawable-set-name selection-channel "selection-channel"))
    ) ;endcond
	(gimp-image-set-active-layer image text-layer)	

    
;;;;begin the script
	(gimp-edit-clear text-layer)
	(gimp-selection-shrink image outer-spacing)
	(gimp-edit-fill text-layer FOREGROUND-FILL)
	(gimp-context-set-foreground fg-color)
	(gimp-context-set-background bg-color)

	(hatched-gradient-overlay image
					    text-layer ;drawable
					    grad
					    0 ;gradtype
					    2 ;repeattype
					    FALSE ;reverse
					    100 ;opacity
					    0 ;mode
					    0 ;cx
					    0 ;cy
					    gradangle
					    gradsize
					    TRUE) ;merge
	
	(set! text-layer (car (gimp-image-get-active-layer image)))
	(gimp-selection-load selection-channel)
	
	(if (> stroke-size 0) (begin
	(hatched-stroke image text-layer
                  0 ;type ; Color(0) Gradient(1) Pattern(2)
				  outline-color
				  100 ;opacity
				  0 ;mode
				  stroke-size
				  stroke-position
				  '(127 255 255) ;fg-color ;not used
                  '(127 255 127) ;bg-color ;not used
                  0 ;blend-mode ;not used
                  "Sunrise" ;gradient ;not used
				  30 ;angle ;not used
                  1 ;scale ;not used
                  0 ;style ;not used
                  0 ;repeat ;not used
				  "Pine?") ;pattern ;not used
	
	(set! text-layer (car (gimp-image-merge-down image (car (gimp-image-get-active-layer image)) EXPAND-AS-NECESSARY)))
	)) ;endif
	
;;;;Scale Image to it's final size;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    (set! aspect (/ final-width (car (gimp-image-width image)))) 
    (gimp-image-scale-full image final-width (* (car (gimp-image-height image)) aspect) 2)
	(set! width (car (gimp-image-width image)))
	(set! height (car (gimp-image-height image)))    
	     
;;;;create the background layer    
	(gimp-selection-none image)
	(if (= bkg-type 0) (begin
	(hatched-aged-paper image text-layer
                               '(207 194 162) ;grunge-color
							   70 ;opacity
							   FALSE ;keep-selection-in
							   conserve)
    )) ;endif
	
	(cond ((or (= bkg-type 1) (= bkg-type 2))
	(set! bkg-layer (car (gimp-layer-new image width height RGBA-IMAGE "Background" 100 NORMAL-MODE)))
	(include-layer image bkg-layer text-layer 1)	;stack 0=above 1=below
    )
	) ;endcond
	(gimp-context-set-pattern bkg-pattern)
	(gimp-context-set-background bkg-color)
	(if (= bkg-type 2) (gimp-drawable-fill bkg-layer PATTERN-FILL))		
    (if (= bkg-type 1) (gimp-drawable-fill bkg-layer BACKGROUND-FILL))	
	;end
;;;;clean up the layers	
	(cond ((or (= bkg-type 1) (= bkg-type 2))
	(if (= conserve FALSE) (begin
	(set! text-layer (car (gimp-image-merge-down image text-layer EXPAND-AS-NECESSARY)))
    (gimp-drawable-set-name text-layer text)	
	)) ;endif
	)) ;endcond
	(if (= conserve FALSE) (gimp-image-remove-channel image selection-channel))

	(gimp-context-pop)
	
    (gimp-display-new image)
	
    )
  ) 
(script-fu-register "script-fu-hatched-logo"
  "Hatched Logo..."
  "Create an image with a text layer over a pattern layer"
  "Graechan"
  "Graechan - http://gimpchat.com"
  "June 2014"
  ""
  SF-TEXT       "Text"    "Hatched\nLogo"
  SF-OPTION "Justify" '("Centered" "Left" "Right")
  SF-ADJUSTMENT "Letter Spacing" '(0 -100 100 1 5 0 0)
  SF-ADJUSTMENT "Line Spacing" '(0 -100 100 1 5 0 0)
  SF-FONT       "Font"               "Sans Bold Italic"
  SF-ADJUSTMENT "Font size (pixels)" '(200 6 500 1 1 0 1)
  SF-GRADIENT		_"Gradient"		"FG to BG (RGB)"
  SF-COLOR "Gradient Foreground Color" '(60 60 60)
  SF-COLOR "Gradient Background Color" '(128 128 128)
  SF-ADJUSTMENT	"Gradient Angle"	'(135 -180 180 1 10 1 0)
  SF-ADJUSTMENT	"Gradient Width"	'(5 0 262144 1 10 1 1)
  SF-COLOR "Outline Color" '(60 60 60)
  SF-ADJUSTMENT	"Outline Size (0 = no outline)"					'(6 0 999 1 10 0 1)
  SF-ADJUSTMENT	"Outline Position (0 = inside, 100 = outside)"	'(100 0 100 1 10 1 0)
  SF-ADJUSTMENT "Outer Spacing" '(10 0 20 1 1 0 0)
  SF-OPTION "Background Type" '("Parchment Paper" "Color" "Pattern" "None")
  SF-COLOR      "Background color"         "White"
  SF-PATTERN    "Background Pattern"            "Pink Marble"
  SF-TOGGLE     "Keep the Layers"   FALSE
  )
(script-fu-menu-register "script-fu-hatched-logo" "<Image>/File/Create/Logos")
;
;----------------------------------------------------------------------------------------------------------
(define (get-blending-mode mode)
  (let* ((modenumbers #(0 1 3 15 4 5 16 17 18 19 20 21 6 7 8 9 10 11 12 13 14)))
    (vector-ref modenumbers mode)
  )
)
(define (math-round input)
  (floor (+ input 0.5))
)

(define (math-ceil input)
  (if (= input (floor input))
    input
    (+ (floor input) 1)
  )
)

(define (get-layer-pos img layer)
  (let* ((layerdata (gimp-image-get-layers img))
	 (numlayers (car layerdata))
	 (layerarray (cadr layerdata))
	 (i 0)
	 (pos -1)
	)
    (while (< i numlayers)
      (if (= layer (vector-ref layerarray i))
	(begin
	  (set! pos i)
	  (set! i numlayers)
	)
	(set! i (+ i 1))
      )
    )
    pos
  )
)

(define (add-under-layer img newlayer oldlayer)
  (gimp-image-add-layer img newlayer (+ (get-layer-pos img oldlayer) 1))
)

(define (add-over-layer img newlayer oldlayer)
  (gimp-image-add-layer img newlayer (get-layer-pos img oldlayer))
)

(define (draw-blurshape img drawable size initgrowth sel invert)
  (let* ((k initgrowth)
	 (currshade 0)
	 (i 0))
    (while (< i size)
      (if (> k 0)
	(gimp-selection-grow img k)
	(if (< k 0)
	  (gimp-selection-shrink img (abs k))
	)
      )
      (if (= invert 1)
	(set! currshade (math-round (* (/ (- size (+ i 1)) size) 255)))
	(set! currshade (math-round (* (/ (+ i 1) size) 255)))
      )
      (gimp-palette-set-foreground (list currshade currshade currshade))
      (if (= (car (gimp-selection-is-empty img)) 0)
	(gimp-edit-fill drawable 0)
      )
      (gimp-selection-load sel)
      (set! k (- k 1))
      (set! i (+ i 1))
    )
  )
)
;------------------------------------------------------------------------------------------------------------------
(define (hatched-gradient-overlay img
					    drawable
					    grad
					    gradtype
					    repeattype
					    reverse
					    opacity
					    mode
					    cx
					    cy
					    gradangle
					    gradsize
					    merge)
  (gimp-image-undo-group-start img)
  (let* ((origgradient (car (gimp-context-get-gradient)))
	 (origselection (car (gimp-selection-save img)))
	 (drwwidth (car (gimp-drawable-width drawable)))
	 (drwheight (car (gimp-drawable-height drawable)))
	 (layername (car (gimp-drawable-get-name drawable)))
	 (drwoffsets (gimp-drawable-offsets drawable))
	 (gradientlayer (car (gimp-layer-new img drwwidth drwheight (cond ((= (car (gimp-image-base-type img)) 0) 1) ((= (car (gimp-image-base-type img)) 1) 3)) (string-append layername "-gradient") opacity (get-blending-mode mode))))
	 (origmask 0)
	 (alphamask 0)
	 (ang (* (* gradangle -1) (/ (* 4 (atan 1.0)) 180)))
	 (offsetX (math-round (* (/ gradsize 2) (cos ang))))
	 (offsetY (math-round (* (/ gradsize 2) (sin ang))))
	 (x1 (- (- cx offsetX) (car drwoffsets)))
	 (y1 (- (- cy offsetY) (cadr drwoffsets)))
	 (x2 (- (+ cx offsetX) (car drwoffsets)))
	 (y2 (- (+ cy offsetY) (cadr drwoffsets)))
	)
    (add-over-layer img gradientlayer drawable)
    (gimp-layer-set-offsets gradientlayer (car drwoffsets) (cadr drwoffsets))
    (gimp-selection-none img)
    (gimp-edit-clear gradientlayer)
    (gimp-context-set-gradient grad)
    (if (and (>= gradtype 6) (<= gradtype 8))
      (gimp-selection-layer-alpha drawable)
    )
    (gimp-edit-blend gradientlayer 3 0 gradtype 100 1 repeattype reverse 0 1 0 0 x1 y1 x2 y2)
    (gimp-selection-none img)
    (if (= merge 1)
      (begin
	(set! origmask (car (gimp-layer-get-mask drawable)))
	(if (> origmask -1)
	  (begin
	    (set! origmask (car (gimp-channel-copy origmask)))
	    (gimp-layer-remove-mask drawable 1)
	  )
	)
	(set! alphamask (car (gimp-layer-create-mask drawable 3)))
	(set! gradientlayer (car (gimp-image-merge-down img gradientlayer 0)))
	(gimp-drawable-set-name gradientlayer layername)
	(gimp-layer-add-mask gradientlayer alphamask)
	(gimp-layer-remove-mask gradientlayer 0)
	(if (> origmask -1)
	  (gimp-layer-add-mask gradientlayer origmask)
	)
      )
      (begin
	(gimp-selection-layer-alpha drawable)
	(if (> (car (gimp-layer-get-mask drawable)) -1)
	  (gimp-selection-combine (car (gimp-layer-get-mask drawable)) 3)
	)
	(set! alphamask (car (gimp-layer-create-mask gradientlayer 4)))
	(gimp-layer-add-mask gradientlayer alphamask)
	(gimp-layer-remove-mask gradientlayer 0)
      )
    )
    (gimp-context-set-gradient origgradient)
    (gimp-selection-load origselection)
    (gimp-image-remove-channel img origselection)
    (gimp-displays-flush)
  )
  (gimp-image-undo-group-end img)
)
;--------------------------------------------------------------------------------------------------------------------
(define (hatched-stroke image layer
                  type ; Color(0) Gradient(1) Pattern(2)
				  color
				  opacity
				  mode
				  size
				  position
				  fg-color ;
                  bg-color ;
                  blend-mode ;
                  gradient ;
				  angle ;
                  scale ;
                  style ;
                  repeat ;
				  pattern ;				  
				  )
	
	(gimp-image-undo-group-start image)						  

 (let* (            
		(width (car (gimp-drawable-width layer)))
		(height (car (gimp-drawable-height layer)))
		(original-width width)
		(original-height height)
		(area (* 1000 1000))
		(alpha (car (gimp-drawable-has-alpha layer)))
		(sel (car (gimp-selection-is-empty image)))
		(typeA (car (gimp-drawable-type-with-alpha layer)))
		(layer-name (car (gimp-drawable-get-name layer)))
		(inc (if (> position 0) (* (/ size 100) position) 0))
		(stroke-layer (car (gimp-layer-new image (+ width (* inc 2)) (+ height (* inc 2)) typeA "Stroke Layer" 100 NORMAL-MODE)))
		(alpha-selection 0)
		(inner-selection 0)
		(outer-selection 0)
		(mask-selection 0)
		(stroke-mask 0)
		(result-layer 0)
		(visible 0)
		(selection-bounds 0)
		(radians (/ (* 2 *pi* angle) 360))
        (x-distance (* 0.5 scale width (sin radians)))
        (y-distance (* 0.5 scale height (cos radians)))
        (x-center (/ width 2))
        (y-center (/ height 2))
        (x1 (- x-center x-distance))
        (y1 (- y-center y-distance))
        (x2 (+ x-center x-distance))
        (y2 (+ y-center y-distance))
        )
	
	(gimp-image-add-layer image stroke-layer -1)
	(if (> position 0) (gimp-layer-set-offsets stroke-layer (- 0 inc) (- 0 inc)))
	
	(gimp-context-push)
    (gimp-context-set-default-colors)

	(if (= alpha FALSE) (gimp-layer-add-alpha layer))
	
;;;;check that a selection was made if not make one	
	(if (= sel TRUE) (gimp-selection-layer-alpha layer))
	
;;;;create selection-channel (gimp-selection-load alpha-selection)    
	(set! alpha-selection (car (gimp-selection-save image)))	
	
;;;;begin the script	
	(if (> position 0) (begin
	(gimp-image-resize-to-layers image)
	(gimp-selection-grow image inc)
	(set! outer-selection (car (gimp-selection-save image)))
	(gimp-edit-fill stroke-layer BACKGROUND-FILL)
	(gimp-image-set-active-layer image stroke-layer)
	(plug-in-autocrop-layer 1 image stroke-layer)
	(gimp-drawable-fill stroke-layer TRANSPARENT-FILL)
	(gimp-image-resize-to-layers image)
	(gimp-selection-load alpha-selection)
	(gimp-selection-shrink image (- size inc))
	(set! inner-selection (car (gimp-selection-save image)))
	))

	(if (= position 0) (begin
	(gimp-selection-load alpha-selection)
	(set! outer-selection (car (gimp-selection-save image)))
	(gimp-selection-shrink image size)
	(set! inner-selection (car (gimp-selection-save image)))
	))
	
;;;;create the selection for mask	
	(gimp-selection-load outer-selection)
	(gimp-selection-combine inner-selection 1)
	(set! mask-selection (car (gimp-selection-save image)))
;	(gimp-selection-none image)
	
	(gimp-context-set-pattern pattern)
	(gimp-context-set-foreground fg-color)
	(gimp-context-set-background bg-color)
	(if (= type 0) (gimp-context-set-background color))
	(gimp-context-set-gradient gradient)
	
	(gimp-image-set-active-layer image stroke-layer)
	
	(if (= type 0) (gimp-edit-fill stroke-layer BACKGROUND-FILL))
	(if (= type 1) (gimp-edit-blend stroke-layer blend-mode NORMAL-MODE style 100 0 repeat FALSE FALSE 0 0 0 x1 y1 x2 y2))
	(if (= type 2) (gimp-edit-fill stroke-layer PATTERN-FILL))
    (gimp-selection-none image)
	(if (= sel FALSE) (gimp-selection-load alpha-selection))
	(gimp-image-remove-channel image alpha-selection)
	(gimp-image-remove-channel image outer-selection)
	(gimp-image-remove-channel image inner-selection)
	(gimp-image-remove-channel image mask-selection)


	(gimp-displays-flush)
	(gimp-image-undo-group-end image)
	(gimp-context-pop)

 )
)
;----------------------------------------------------------------------------------------------------------------------------
(define (hatched-aged-paper image drawable
                               grunge-color
							   opacity
							   keep-selection-in
							   conserve)							  

 (let* (
            (image-layer (car (gimp-image-get-active-layer image)))
			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))
			(alpha (car (gimp-drawable-has-alpha image-layer)))
		    (sel (car (gimp-selection-is-empty image)))
		    (layer-name (car (gimp-drawable-get-name image-layer)))
		    (keep-selection keep-selection-in)
			(selection-channel 0)
			(paper-layer 0)
			(mottle-layer 0)
			(bump-layer 0)
			(nominal-burn-size 30)
			(burn-size 0)
        )
	
	(set! burn-size (/ (* nominal-burn-size (max width height 1))))
	(gimp-context-push)
    (gimp-image-undo-group-start image)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))

    (if (= alpha FALSE) (gimp-layer-add-alpha image-layer))
	
;;;;check that a selection was made if not make one	
	(if (= sel TRUE) (set! keep-selection FALSE))
	(if (= sel TRUE) (gimp-selection-all image)) ;(gimp-selection-layer-alpha image-layer))
	
;;;;create selection-channel
    (gimp-selection-save image)
	(set! selection-channel (car (gimp-image-get-active-drawable image)))	
	(gimp-channel-set-opacity selection-channel 100)	
	(gimp-drawable-set-name selection-channel "selection-channel")
    (gimp-image-set-active-layer image image-layer)	
	(gimp-selection-none image)		
	
	(set! paper-layer (car (gimp-layer-new image width height RGBA-IMAGE "Paper Layer" 100 NORMAL-MODE)))
	(gimp-image-add-layer image paper-layer 1)
	(gimp-context-set-background grunge-color)
    (gimp-edit-fill paper-layer BACKGROUND-FILL)
	(plug-in-apply-canvas RUN-NONINTERACTIVE image paper-layer 0 1)
	(set! mottle-layer (car (gimp-layer-new image width height RGBA-IMAGE "Mottle Layer" opacity 21)))
	(gimp-image-add-layer image mottle-layer 1)
    (plug-in-solid-noise RUN-NONINTERACTIVE image mottle-layer 0 0 (rand 65536) 1 2 2)
    (set! paper-layer (car (gimp-image-merge-down image mottle-layer CLIP-TO-IMAGE)))
	(plug-in-spread 1 image paper-layer 5 5)
		
	(set! bump-layer (car (gimp-layer-new image width height RGBA-IMAGE "bump-layer" 100  GRAIN-EXTRACT-MODE)))
	(gimp-image-add-layer image bump-layer 1)
	(gimp-context-set-pattern "Slate")
	(gimp-drawable-fill bump-layer PATTERN-FILL)
	(plug-in-bump-map 1 image paper-layer bump-layer 135 45 3 0 0 0 0 TRUE FALSE 0)
	(gimp-image-remove-layer image bump-layer)
	
	(gimp-selection-load selection-channel)
	;(gimp-selection-all image)
	(gimp-selection-shrink image 10)
	(script-fu-distress-selection image 
	                              paper-layer 
								  127       ;Threshold (bigger 1<-->255 smaller)
								  8         ;Spread (8 0 1000 1 10 0 1)
								  4         ;Granularity (1 is low) (4 1 25 1 10 0 1)
								  2         ;Smooth (2 1 150 1 10 0 1)
								  TRUE      ;Smooth horizontally TRUE
								  TRUE)     ;Smooth vertically TRUE
	(gimp-selection-invert image)
	(gimp-edit-clear paper-layer)
	;(gimp-edit-clear bump-layer)
	(gimp-edit-clear image-layer)
	(gimp-selection-none image)
	(gimp-layer-set-mode image-layer 21)
	(gimp-brightness-contrast image-layer 0 30)
;	;(set! image-layer (car (gimp-image-merge-visible-layers image EXPAND-AS-NECESSARY)))
;	;(plug-in-curve-bend 1 image image-layer 90 TRUE TRUE FALSE 0 17 +0.498039 17 +0.647059 17 +0.509804 17 +0.752941 -1 -1 -1 -1)
;	
;;;;finish the script	
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))
	(if (= conserve FALSE) (set! image-layer (car (gimp-image-merge-down image image-layer EXPAND-AS-NECESSARY))))
    (gimp-drawable-set-name image-layer layer-name)
    (if (= keep-selection FALSE) (gimp-selection-none image))
	(gimp-image-remove-channel image selection-channel)
	(if (and (= conserve FALSE) (= alpha FALSE) (gimp-layer-flatten image-layer)))	
    
	(gimp-displays-flush)
	(gimp-image-undo-group-end image)
	(gimp-context-pop)

 )
) 