; Inlayed rel 0.03
; Created by Graechan
; Thanks to Chris F for the tutorial I followed at http://www.youtube.com/watch?v=gkcUhsITbWk
; For the default font I used 'Orbit Racer' also from Chris F at http://www.dafont.com/search.php?q=orbit+racer
; Comments directed to http://gimpchat.com or http://gimpscripts.com
;
; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html
;
;
; ------------
;| Change Log |
; ------------ 
; Rel 0.01 - Initial Release
; Rel 0.02 - Added Alpha-to-Logo Inlay Script
; Rel 0.03 - Bugfix releases
(define (script-fu-inlayed-text 
                                      text
									  letter-spacing
									  line-spacing
                                      font-in 
                                      font-size
									  inlay-adj
									  shadow-size
									  shadow-blur
									  shadow-opacity
									  fill-type
									  fill-pattern
                                      bkg-type 
                                      pattern
                                      bkg-color
									  gradient
									  rad
							          blur
									  border-color
									  conserve)
									  
  (let* (
         (image (car (gimp-image-new 256 256 RGB)))         
         (border (/ font-size 4))
		 (font (if (> (string-length font-in) 0) font-in (car (gimp-context-get-font))))
         (size-layer (car (gimp-text-fontname image -1 0 0 text border TRUE font-size PIXELS font)))
         (final-width (car (gimp-drawable-width size-layer)))
         (final-height (car (gimp-drawable-height size-layer)))
         (text-layer 0)
         (width 0)
         (height 0)
         (bkg-layer 0)
		 (text-selection 0)
		 (fill-layer 0)
		 (fill-selection 0)
		 (inner-shadow 0)
		 (shadow-mask 0)
		 (offx shadow-size)
		 (offy shadow-size)
		 (frame-layer 0)
		 (a1 600)
		 (a2 (round (/ a1 40)))         
         )
		 
    (gimp-context-push)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))

;;;;Add the text layer for a temporary larger Image size
    (set! text-layer (car (gimp-text-fontname image -1 0 0 text (round (/ a1 4)) TRUE a1 PIXELS font)))
;;;;adjust text on line
	(gimp-text-layer-set-justification text-layer 2)
	(gimp-text-layer-set-letter-spacing text-layer letter-spacing)
	(gimp-text-layer-set-line-spacing text-layer line-spacing)
    (set! width (car (gimp-drawable-width text-layer)))
    (set! height (car (gimp-drawable-height text-layer)))    
    (gimp-image-remove-layer image size-layer)
    (gimp-image-resize-to-layers image)
	
;;;;set the text selection    
	(gimp-selection-layer-alpha text-layer)
	(set! text-selection (car (gimp-selection-save image))) ;(gimp-selection-load text-selection)
	(gimp-image-set-active-layer image text-layer)
	(gimp-edit-fill text-layer FOREGROUND-FILL)

;;;;start of script;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    (script-fu-chrome-logo-alpha  image text-layer 20 '(211 211 211))
	(set! text-layer (car (gimp-image-merge-down image (car (gimp-image-get-active-layer image )) EXPAND-AS-NECESSARY)))
	(gimp-drawable-set-name text-layer text)
	
;;;;create  the fill layer
	(set! fill-layer (car (gimp-layer-new image width height RGBA-IMAGE "fill" 100 NORMAL-MODE)))
	(gimp-image-add-layer image fill-layer (car (gimp-image-get-layer-position image text-layer))) ;over
	(gimp-selection-load text-selection)
	(gimp-selection-shrink image (- a2 inlay-adj))
	(gimp-edit-fill fill-layer FOREGROUND-FILL)
	(gimp-selection-shrink image 3)
	(set! fill-selection (car (gimp-selection-save image))) ;(gimp-selection-load fill-selection)
	
;;;;fill the inside of the text with a pattern
	(if (= fill-type 0) (begin
	(gimp-context-set-pattern "Dried mud")
	(gimp-edit-fill fill-layer PATTERN-FILL)
	(gimp-hue-saturation fill-layer 0 160 -40 100)
	(gimp-brightness-contrast fill-layer 0 20)))
	(if (= fill-type 1) (begin
	(gimp-context-set-pattern fill-pattern)
	(gimp-edit-fill fill-layer PATTERN-FILL)))
    
;;;;create the inner shadow
    (set! inner-shadow (car (gimp-layer-new image width height RGBA-IMAGE "Inner Shadow" shadow-opacity NORMAL-MODE)))
    (gimp-image-add-layer image inner-shadow (car (gimp-image-get-layer-position image fill-layer))) ;over    
    (gimp-selection-load fill-selection)
	(gimp-drawable-fill inner-shadow FOREGROUND-FILL)
	(gimp-edit-clear inner-shadow)
	(gimp-selection-none image)
	(gimp-layer-set-offsets inner-shadow offx offy)
	(gimp-layer-resize-to-image-size inner-shadow)
	(plug-in-gauss-iir2 1 image inner-shadow shadow-blur shadow-blur)
;;;;create the mask for inner shadow	
	(gimp-selection-load fill-selection)
	(set! shadow-mask (car (gimp-layer-create-mask inner-shadow ADD-SELECTION-MASK)))
	(gimp-layer-add-mask inner-shadow shadow-mask)	
	(gimp-selection-none image)
	(gimp-layer-remove-mask inner-shadow 0)
	
;;;;create the background layer
	(set! bkg-layer (car (gimp-layer-new image width height RGBA-IMAGE "Background" 100 NORMAL-MODE)))
    (gimp-image-add-layer image bkg-layer (+ (car (gimp-image-get-layer-position image text-layer)) 1)) ;under 
	(set! bkg-layer (car (gimp-image-merge-down image bkg-layer EXPAND-AS-NECESSARY)))
    (gimp-drawable-fill bkg-layer BACKGROUND-FILL)
	
	(if (= bkg-type 0) (begin
	(script-fu-line-nova image bkg-layer 200 1 100 30)
	(gimp-image-set-active-layer image bkg-layer)
	(plug-in-nova 1 image bkg-layer (/ width 2) (/ height 2) "yellow" 70 100 360)))
	
;;;;Scale Image to it's original size;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    (gimp-image-scale-full image final-width final-height 2)
	(set! width (car (gimp-image-width image)))
	(set! height (car (gimp-image-height image)))
	
;;;;create the other background options    
	(if (> bkg-type 0) (begin
	(gimp-context-set-pattern pattern)
	(gimp-context-set-background bkg-color)
	(gimp-context-set-gradient gradient)
	(if (= bkg-type 1) (gimp-drawable-fill bkg-layer PATTERN-FILL))		
    (if (= bkg-type 2) (gimp-drawable-fill bkg-layer BACKGROUND-FILL))	
    (if (= bkg-type 3) (gimp-edit-blend bkg-layer CUSTOM-MODE NORMAL-MODE  GRADIENT-LINEAR 100 0 REPEAT-NONE FALSE FALSE 3 0.2 TRUE 0 0 width height));; GRADIENT-LINEAR ; GRADIENT-CONICAL-SYMMETRIC
    (if (= bkg-type 4) (gimp-drawable-fill bkg-layer TRANSPARENT-FILL))
    ))

	(if (> rad 0) (the-borderize  image bkg-layer (/ blur 4) rad blur 90 border-color FALSE))

;;;;resize the text-layer		
    (gimp-image-set-active-layer image text-layer)
	(gimp-layer-resize-to-image-size text-layer)    

;;;;end of script;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
    (if (= conserve FALSE) (set! text-layer (car (gimp-image-merge-visible-layers image 0))))
    (gimp-drawable-set-name text-layer text)
	(gimp-image-remove-channel image text-selection)
	
	(gimp-context-pop)

    (gimp-display-new image)
    )
  ) 
(script-fu-register "script-fu-inlayed-text"
  "Inlayed Text..."
  "Create an image with a text layer over a pattern layer"
  "Graechan"
  "Graechan - http://gimpchat.com"
  "April 2013"
  ""
  SF-TEXT       "Text"    "GIMP"
  SF-ADJUSTMENT "Letter Spacing" '(0 -100 100 1 5 0 0)
  SF-ADJUSTMENT "Line Spacing" '(0 -100 100 1 5 0 0)
  SF-FONT       "Font"               "Orbit Racer"
  SF-ADJUSTMENT "Font size (pixels)" '(400 6 500 1 1 0 1)
  SF-ADJUSTMENT "Inlay Adj" '(0 -5 5 1 1 0 0)
  SF-ADJUSTMENT "Shadow Offset" '(25 0 50 1 5 0 0)
  SF-ADJUSTMENT "Shadow Blur" '(25 0 50 1 5 0 0)
  SF-ADJUSTMENT "Shadow Opacity" '(75 0 100 1 5 0 0)
  SF-OPTION     "Fill Type" '("Default" "Pattern")
  SF-PATTERN    "Fill Pattern"            "Blue Web"
  SF-OPTION "Background Type" '("default" "Pattern" "Color" "Gradient" "None")
  SF-PATTERN    "Pattern"            "Pink Marble"
  SF-COLOR      "Background color"         "White"
  SF-GRADIENT   "Background Gradient" "Abstract 3"
  SF-ADJUSTMENT "Corner Radius(0=no border)" '(50 0 300 1 10 0 0)
  SF-ADJUSTMENT "Border Shadow Blur" '(18 0 50 1 10 0 0)
  SF-COLOR      "Border Color"         '(0 0 0)
  SF-TOGGLE     "Keep the Layers"   FALSE
  )
(script-fu-menu-register "script-fu-inlayed-text" "<Image>/File/Create/Logos")

(define (script-fu-inlay image layer
                               inlay-adj
							   shadow-size
							   shadow-blur
							   shadow-opacity
							   fill-type
							   fill-pattern
                               bkg-type 
                               pattern
                               bkg-color
							   gradient
							   rad
							   blur
							   border-color
							   keep-selection-in
							   conserve)
							   
	(gimp-image-undo-group-start image)					  

 (let* (
            
			(layer-width (car (gimp-drawable-width layer)))
			(layer-height (car (gimp-drawable-height layer)))
			(width (car (gimp-image-width image)))
	        (height (car (gimp-image-height image)))
			(final-width width)
			(final-height height)
			(x (car (gimp-drawable-offsets layer))) ;x 
			(y (cadr (gimp-drawable-offsets layer))) ;y 
			(offx (/ (- width layer-width) 2))
			(offy (/ (- height layer-height) 2))
			(area (* 1000 1000))
			(alpha (car (gimp-drawable-has-alpha layer)))
		    (sel (car (gimp-selection-is-empty image)))
		    (layer-name (car (gimp-drawable-get-name layer)))
			(layerList (vector->list (cadr (gimp-image-get-layers image))))
			(layerId 0)
		    (keep-selection keep-selection-in)
			(selection-channel 0)
			(fill-layer 0)
		    (fill-selection 0)
		    (inner-shadow 0)
		    (shadow-mask 0)
			(bkg-layer 0)
		    (frame-layer 0)
		    (a1 600)
		    (a2 (round (/ a1 40))) 
        )

;;;;set all layers except the active layer to invisible		
	(while (not (null? layerList))
          (set! layerId (car layerList))
		  (gimp-drawable-set-visible layerId FALSE)
		  (set! layerList (cdr layerList)))
	(gimp-drawable-set-visible layer TRUE)
	

;;;;centre the layer        
    (gimp-layer-set-offsets layer offx offy)
;;;;scale the layer to the image size	
	(gimp-layer-scale layer (car (gimp-image-width image)) (car (gimp-image-height image)) TRUE)		
	

;;;;scale image to given area if required	
	(gimp-image-scale image 
	(max 1 (min 262144 (round (* width (sqrt (/ area (* width height)))))))
	(max 1 (min 262144 (round (* height (sqrt (/ area (* width height))))))))
	(set! width (car (gimp-image-width image)))
	(set! height (car (gimp-image-height image)))
	
	(gimp-context-push)
    (gimp-context-set-default-colors)

	(if (= alpha FALSE) (gimp-layer-add-alpha layer))
	
;;;;check that a selection was made if not make one	
	(if (= sel TRUE) (set! keep-selection FALSE))
	(if (= sel TRUE) (gimp-selection-layer-alpha layer))
	
;;;;create selection-channel (gimp-selection-load selection-channel)
    (set! selection-channel (car (gimp-selection-save image)))
	(gimp-image-set-active-layer image layer)
	(gimp-edit-fill layer FOREGROUND-FILL)	
	(gimp-selection-none image)	
;;;;begin the script	
    (script-fu-chrome-logo-alpha  image layer 20 '(211 211 211))
	(set! layer (car (gimp-image-merge-down image (car (gimp-image-get-active-layer image )) EXPAND-AS-NECESSARY)))
	(gimp-drawable-set-name layer layer-name)	
	
;;;;create  the fill layer
	(set! fill-layer (car (gimp-layer-new image width height RGBA-IMAGE "fill" 100 NORMAL-MODE)))
	(gimp-image-add-layer image fill-layer (car (gimp-image-get-layer-position image layer))) ;over
	(gimp-selection-load selection-channel)
	(gimp-selection-shrink image (- a2 inlay-adj))
	(gimp-edit-fill fill-layer FOREGROUND-FILL)
	(gimp-selection-shrink image 3)
	(set! fill-selection (car (gimp-selection-save image))) ;(gimp-selection-load fill-selection)	
	
;;;;fill the inside  with a pattern
	(if (= fill-type 0) (begin
	(gimp-context-set-pattern "Dried mud")
	(gimp-edit-fill fill-layer PATTERN-FILL)
	(gimp-hue-saturation fill-layer 0 160 -40 100)
	(gimp-brightness-contrast fill-layer 0 20)))
	(if (= fill-type 1) (begin
	(gimp-context-set-pattern fill-pattern)
	(gimp-edit-fill fill-layer PATTERN-FILL)))	
	
;;;;create the inner shadow
    (set! inner-shadow (car (gimp-layer-new image width height RGBA-IMAGE "Inner Shadow" shadow-opacity NORMAL-MODE)))
    (gimp-image-add-layer image inner-shadow (car (gimp-image-get-layer-position image fill-layer))) ;over    
    (gimp-selection-load fill-selection)
	(gimp-drawable-fill inner-shadow FOREGROUND-FILL)
	(gimp-edit-clear inner-shadow)
	(gimp-selection-none image)
	(gimp-layer-set-offsets inner-shadow shadow-size shadow-size)
	(gimp-layer-resize-to-image-size inner-shadow)
	(plug-in-gauss-iir2 1 image inner-shadow shadow-blur shadow-blur)
;;;;create the mask for inner shadow	
	(gimp-selection-load fill-selection)
	(set! shadow-mask (car (gimp-layer-create-mask inner-shadow ADD-SELECTION-MASK)))
	(gimp-layer-add-mask inner-shadow shadow-mask)	
	(gimp-selection-none image)
	(gimp-layer-remove-mask inner-shadow 0)	
	
;;;;create the background layer
	(set! bkg-layer (car (gimp-layer-new image width height RGBA-IMAGE "Background" 100 NORMAL-MODE)))
    (gimp-image-add-layer image bkg-layer (+ (car (gimp-image-get-layer-position image layer)) 1)) ;under 
	(set! bkg-layer (car (gimp-image-merge-down image bkg-layer EXPAND-AS-NECESSARY)))
    (gimp-drawable-fill bkg-layer BACKGROUND-FILL)
	
;;;;create the default background
	(if (= bkg-type 0) (begin
	(script-fu-line-nova image bkg-layer 200 1 100 30)
	(gimp-image-set-active-layer image bkg-layer)
	(plug-in-nova 1 image bkg-layer (/ width 2) (/ height 2) "yellow" 70 100 360)))
	
;;;;create the other background options    
	(if (> bkg-type 0) (begin
	(gimp-context-set-pattern pattern)
	(gimp-context-set-background bkg-color)
	(gimp-context-set-gradient gradient)
	(if (= bkg-type 1) (gimp-drawable-fill bkg-layer PATTERN-FILL))		
    (if (= bkg-type 2) (gimp-drawable-fill bkg-layer BACKGROUND-FILL))	
    (if (= bkg-type 3) (gimp-edit-blend bkg-layer CUSTOM-MODE NORMAL-MODE  GRADIENT-LINEAR 100 0 REPEAT-NONE FALSE FALSE 3 0.2 TRUE 0 0 width height));; GRADIENT-LINEAR ; GRADIENT-CONICAL-SYMMETRIC
    (if (= bkg-type 4) (gimp-drawable-fill bkg-layer TRANSPARENT-FILL))
    ))	
	
;;;;create the border
	(if (> rad 0) (the-borderize  image bkg-layer (/ blur 4) rad blur 90 border-color FALSE))
	
;;;;finish the script	
	(if (= conserve FALSE) (set! layer (car (gimp-image-merge-visible-layers image EXPAND-AS-NECESSARY))))
    (gimp-drawable-set-name layer layer-name)
    (if (= keep-selection TRUE) (gimp-selection-load selection-channel))
	(gimp-image-remove-channel image selection-channel)
	(gimp-image-remove-channel image fill-selection)

;;;;Scale Image to it's original size;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    (gimp-image-scale-full image final-width final-height 2)
	(if (= conserve FALSE) (begin
	(gimp-layer-scale layer layer-width layer-height TRUE)
	(gimp-layer-set-offsets layer x y)))
	
;;;;scale all visible layers
	(if (= conserve TRUE) (begin
    (set! layerList (vector->list (cadr (gimp-image-get-layers image))))
	(while (not (null? layerList))
    (set! layerId (car layerList))
	(if (= (car(gimp-layer-get-visible layerId)) TRUE) (begin
	(gimp-layer-scale layerId layer-width layer-height TRUE)
	(gimp-layer-set-offsets layerId x y)))
	(set! layerList (cdr layerList)))))	
          
;;;;reset all layers to visible
    (set! layerList (vector->list (cadr (gimp-image-get-layers image))))
	(while (not (null? layerList))
          (set! layerId (car layerList))
		  (gimp-drawable-set-visible layerId TRUE)
		  (set! layerList (cdr layerList)))
		  
	
	(gimp-displays-flush)
	(gimp-image-undo-group-end image)
	(gimp-context-pop)

 )
)

(script-fu-register "script-fu-inlay"        		    
  "Inlay..."
  "Inlays an image with alpha background or a selection with a pattern"
  "Graechan"
  "Graechan - http://gimpchat.com"
  "April 2013"
  "RGB*"
  SF-IMAGE      "image"      0
  SF-DRAWABLE   "drawable"   0
  SF-ADJUSTMENT "Inlay Adj" '(0 -5 5 1 1 0 0)
  SF-ADJUSTMENT "Shadow Offset" '(25 0 50 1 5 0 0)
  SF-ADJUSTMENT "Shadow Blur" '(25 0 50 1 5 0 0)
  SF-ADJUSTMENT "Shadow Opacity" '(75 0 100 1 5 0 0)
  SF-OPTION     "Fill Type" '("Default" "Pattern")
  SF-PATTERN    "Fill Pattern"            "Blue Web"
  SF-OPTION "Background Type" '("default" "Pattern" "Color" "Gradient" "None")
  SF-PATTERN    "Pattern"            "Pink Marble"
  SF-COLOR      "Background color"         "White"
  SF-GRADIENT   "Background Gradient" "Abstract 3"
  SF-ADJUSTMENT "Corner Radius(0=no border)" '(50 0 300 1 10 0 0)
  SF-ADJUSTMENT "Border Shadow Blur" '(18 0 50 1 10 0 0)
  SF-COLOR      "Border Color"         '(0 0 0)
  SF-TOGGLE     "Keep selection"          FALSE
  SF-TOGGLE     "Keep the Layers"   FALSE
)

(script-fu-menu-register "script-fu-inlay" "<Image>/Filters/Alpha to Logo")
 
(define (the-borderize image drawable
                               border
							   rad
							   blur
							   opacity
							   color
                               keep-selection-in							   
							   )
							  

 (let* (
            (width (car (gimp-drawable-width drawable)))
			(height (car (gimp-drawable-height drawable)))
			(original-width width)
			(original-height height)
			(offx (car (gimp-drawable-offsets drawable)))
			(offy (cadr (gimp-drawable-offsets drawable)))
			(alpha (car (gimp-drawable-has-alpha drawable)))
		    (sel (car (gimp-selection-is-empty image)))
		    (keep-selection keep-selection-in)
			(selection-channel 0)
			(border-layer 0)
        )
	
	
	(gimp-context-push)
    (gimp-image-undo-group-start image)
	(gimp-context-set-default-colors)

	(if (= alpha FALSE) (gimp-layer-add-alpha drawable))
	
;;;;check that a selection was made if not make one	
	(if (= sel TRUE) (set! keep-selection FALSE))
	
;;;;create selection-channel (gimp-selection-load selection-channel)
    (if (= sel FALSE) (begin
	(gimp-selection-save image)
	(set! selection-channel (car (gimp-image-get-active-drawable image)))	
	(gimp-channel-set-opacity selection-channel 100)	
	(gimp-drawable-set-name selection-channel "selection-channel")
    (gimp-image-set-active-layer image drawable)	
	(gimp-selection-none image)))	
;;;;begin the script	
	(gimp-round-rect-select image 
	                        offx ;x 
							offy ;y 
							width ;width 
							height ;height 
							rad ;corner-radius-x 
							rad ;corner-radius-y 
							2 ;operation  { CHANNEL-OP-ADD (0), CHANNEL-OP-SUBTRACT (1), CHANNEL-OP-REPLACE (2), CHANNEL-OP-INTERSECT (3) } 
							TRUE ;antialias 
							FALSE ;feather 
							0 ;feather-radius-x 
							0);feather-radius-y
							
	(gimp-selection-invert image)
    (gimp-edit-clear drawable)
	(gimp-selection-invert image)						
							
(gimp-round-rect-select image 
	                        (+ offx border);x 
							(+ offy border) ;y 
							(- width (* border 2)) ;width 
							(- height (* border 2)) ;height 
							rad ;corner-radius-x 
							rad ;corner-radius-y 
							1 ;operation  { CHANNEL-OP-ADD (0), CHANNEL-OP-SUBTRACT (1), CHANNEL-OP-REPLACE (2), CHANNEL-OP-INTERSECT (3) } 
							TRUE ;antialias 
							TRUE ;feather 
							blur ;feather-radius-x 
							blur);feather-radius-y

	(gimp-context-set-foreground color)
	(gimp-edit-bucket-fill drawable 0 0 opacity 15 FALSE 0 0)						
	(gimp-selection-none image)
	
;;;;finish the script	

    (if (= keep-selection TRUE) (begin
	(gimp-selection-load selection-channel)
	(gimp-image-remove-channel image selection-channel)))
	
	(gimp-displays-flush)
	(gimp-image-undo-group-end image)
	(gimp-context-pop)

 )
)

